Index: src/backend/parser/gram.y
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/parser/gram.y,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.1
diff -c -r1.1.1.3 -r1.1.1.3.2.1
*** src/backend/parser/gram.y	19 May 2009 06:59:32 -0000	1.1.1.3
--- src/backend/parser/gram.y	26 May 2009 08:04:45 -0000	1.1.1.3.2.1
***************
*** 108,114 ****
   */
  /*#define __YYSCLASS*/
  
! static Node *makeColumnRef(char *colname, List *indirection, int location);
  static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
  static Node *makeStringConst(char *str, int location);
  static Node *makeStringConstCast(char *str, int location, TypeName *typename);
--- 108,114 ----
   */
  /*#define __YYSCLASS*/
  
! Node *makeColumnRef(char *colname, List *indirection, int location);
  static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
  static Node *makeStringConst(char *str, int location);
  static Node *makeStringConstCast(char *str, int location, TypeName *typename);
***************
*** 178,183 ****
--- 178,185 ----
  
  	InsertStmt			*istmt;
  	VariableSetStmt		*vsetstmt;
+ 
+ 	PartitionFunction partFunc;
  }
  
  %type <node>	stmt schema_stmt
***************
*** 417,422 ****
--- 419,429 ----
  %type <ival>	opt_frame_clause frame_extent frame_bound
  
  
+ %type <list>	ListPartitionList RangePartitions ListPartitions PartitionColumns
+ %type <node> 	PartitioningData OptPartition ListPartition RangePartition
+ %type <range>	OptPartitionName
+ 
+ 
  /*
   * If you make any token changes, update the keyword table in
   * src/include/parser/kwlist.h and add new keywords to the appropriate one of
***************
*** 445,451 ****
  	DEFERRABLE DEFERRED DEFINER DELETE_P DELIMITER DELIMITERS DESC
  	DICTIONARY DISABLE_P DISCARD DISTINCT DO DOCUMENT_P DOMAIN_P DOUBLE_P DROP
  
! 	EACH ELSE ENABLE_P ENCODING ENCRYPTED END_P ENUM_P ESCAPE EXCEPT
  	EXCLUDING EXCLUSIVE EXECUTE EXISTS EXPLAIN EXTERNAL EXTRACT
  
  	FALSE_P FAMILY FETCH FIRST_P FLOAT_P FOLLOWING FOR FORCE FOREIGN FORWARD
--- 452,458 ----
  	DEFERRABLE DEFERRED DEFINER DELETE_P DELIMITER DELIMITERS DESC
  	DICTIONARY DISABLE_P DISCARD DISTINCT DO DOCUMENT_P DOMAIN_P DOUBLE_P DROP
  
! 	EACH ELSE ENABLE_P ENCODING ENCRYPTED END_P ENUM_P ESCAPE EXCEPT EXCHANGE 
  	EXCLUDING EXCLUSIVE EXECUTE EXISTS EXPLAIN EXTERNAL EXTRACT
  
  	FALSE_P FAMILY FETCH FIRST_P FLOAT_P FOLLOWING FOR FORCE FOREIGN FORWARD
***************
*** 465,474 ****
  	KEY
  
  	LANCOMPILER LANGUAGE LARGE_P LAST_P LC_COLLATE_P LC_CTYPE_P LEADING
! 	LEAST LEFT LEVEL LIKE LIMIT LISTEN LOAD LOCAL LOCALTIME LOCALTIMESTAMP
  	LOCATION LOCK_P LOGIN_P
  
! 	MAPPING MATCH MAXVALUE MINUTE_P MINVALUE MODE MONTH_P MOVE
  
  	NAME_P NAMES NATIONAL NATURAL NCHAR NEW NEXT NO NOCREATEDB
  	NOCREATEROLE NOCREATEUSER NOINHERIT NOLOGIN_P NONE NOSUPERUSER
--- 472,481 ----
  	KEY
  
  	LANCOMPILER LANGUAGE LARGE_P LAST_P LC_COLLATE_P LC_CTYPE_P LEADING
! 	LEAST LEFT LEVEL LIKE LIST1 LIMIT LISTEN LOAD LOCAL LOCALTIME LOCALTIMESTAMP
  	LOCATION LOCK_P LOGIN_P
  
! 	MAPPING MATCH MAXVALUE MERGE MINUTE_P MINVALUE MODE MONTH_P MOVE
  
  	NAME_P NAMES NATIONAL NATURAL NCHAR NEW NEXT NO NOCREATEDB
  	NOCREATEROLE NOCREATEUSER NOINHERIT NOLOGIN_P NONE NOSUPERUSER
***************
*** 477,483 ****
  	OBJECT_P OF OFF OFFSET OIDS OLD ON ONLY OPERATOR OPTION OPTIONS OR
  	ORDER OUT_P OUTER_P OVER OVERLAPS OVERLAY OWNED OWNER
  
! 	PARSER PARTIAL PARTITION PASSWORD PLACING PLANS POSITION
  	PRECEDING PRECISION PRESERVE PREPARE PREPARED PRIMARY
  	PRIOR PRIVILEGES PROCEDURAL PROCEDURE
  
--- 484,490 ----
  	OBJECT_P OF OFF OFFSET OIDS OLD ON ONLY OPERATOR OPTION OPTIONS OR
  	ORDER OUT_P OUTER_P OVER OVERLAPS OVERLAY OWNED OWNER
  
! 	PARSER PARTIAL PARTITION PARTITIONS PASSWORD PLACING PLANS POSITION
  	PRECEDING PRECISION PRESERVE PREPARE PREPARED PRIMARY
  	PRIOR PRIVILEGES PROCEDURAL PROCEDURE
  
***************
*** 489,495 ****
  
  	SAVEPOINT SCHEMA SCROLL SEARCH SECOND_P SECURITY SELECT SEQUENCE
  	SERIALIZABLE SERVER SESSION SESSION_USER SET SETOF SHARE
! 	SHOW SIMILAR SIMPLE SMALLINT SOME STABLE STANDALONE_P START STATEMENT
  	STATISTICS STDIN STDOUT STORAGE STRICT_P STRIP_P SUBSTRING SUPERUSER_P
  	SYMMETRIC SYSID SYSTEM_P
  
--- 496,502 ----
  
  	SAVEPOINT SCHEMA SCROLL SEARCH SECOND_P SECURITY SELECT SEQUENCE
  	SERIALIZABLE SERVER SESSION SESSION_USER SET SETOF SHARE
! 	SHOW SIMILAR SIMPLE SMALLINT SOME SPLIT STABLE STANDALONE_P START STATEMENT
  	STATISTICS STDIN STDOUT STORAGE STRICT_P STRIP_P SUBSTRING SUPERUSER_P
  	SYMMETRIC SYSID SYSTEM_P
  
***************
*** 1542,1549 ****
  		;
  
  alter_table_cmd:
  			/* ALTER TABLE <name> ADD [COLUMN] <coldef> */
! 			ADD_P opt_column columnDef
  				{
  					AlterTableCmd *n = makeNode(AlterTableCmd);
  					n->subtype = AT_AddColumn;
--- 1549,1565 ----
  		;
  
  alter_table_cmd:
+ 			/* ALTER TABLE <name> ADD PARTITION BY RANGE (col, ...) (<name> START val,.... END val,....) */
+ 			ADD_P RANGE PARTITION RangePartition
+ 				{
+ 					AlterTableCmd *n = makeNode(AlterTableCmd);
+ 					n->subtype = AT_AddPartition;
+ 					n->def = $4;
+ 					$$ = (Node *)n;
+ 				}		
+ 
  			/* ALTER TABLE <name> ADD [COLUMN] <coldef> */
! 			| ADD_P opt_column columnDef
  				{
  					AlterTableCmd *n = makeNode(AlterTableCmd);
  					n->subtype = AT_AddColumn;
***************
*** 1593,1598 ****
--- 1609,1691 ----
  					n->def = (Node *) makeString($6);
  					$$ = (Node *)n;
  				}
+ 			| RENAME PARTITION qualified_name TO qualified_name
+ 				{
+ 					AlterTableCmd *n = makeNode(AlterTableCmd);
+ 					RenamePartitionStmt *s = makeNode(RenamePartitionStmt);
+                     s->partNames = lappend(s->partNames, $3);
+                     s->partNames = lappend(s->partNames, $5);					
+ 					n->subtype = AT_RenamePartition;
+ 					n->def = (Node *)s;
+ 					$$ = (Node *)n;
+ 				}
+ 			| DROP PARTITION qualified_name 
+ 				{
+ 					AlterTableCmd *n = makeNode(AlterTableCmd);
+                     Partition *partition = makeNode(Partition);
+ 
+ 					n->subtype = AT_DropPartitionByName;
+                     partition->partName = $3;
+                     partition->partitionCheck = NULL;
+ 
+ 					n->def = (Node *)partition;
+ 					$$ = (Node *)n;
+ 				}
+ 			| DROP PARTITION RangePartition
+ 				{
+ 					AlterTableCmd *n = makeNode(AlterTableCmd);
+ 					n->subtype = AT_DropPartitionByRange;
+ 					n->def = $3;
+ 					$$ = (Node *)n;
+ 				}
+ 			| EXCHANGE qualified_name WITH TABLE qualified_name
+ 				{
+ 					AlterTableCmd *n = makeNode(AlterTableCmd);
+ 					ExchangePartitionStmt *s = makeNode(ExchangePartitionStmt);
+                     s->partNames = lappend(s->partNames, $2);
+                     s->partNames = lappend(s->partNames, $5);					
+ 					n->subtype = AT_ExchangePartition;
+ 					n->def = (Node *)s;
+ 					$$ = (Node *)n;
+ 				}
+ 			| UPDATE PARTITION RangePartition
+ 				{
+ 					AlterTableCmd *n = makeNode(AlterTableCmd);
+ 					n->subtype = AT_UpdatePartition;
+ 					n->def = $3;
+ 					$$ = (Node *)n;
+ 				}
+ 			| UPDATE PARTITIONS TO ICONST 
+ 				{
+ 					AlterTableCmd *n = makeNode(AlterTableCmd);
+ 					n->subtype = AT_UpdateHashPartition;
+ 					n->def = makeIntConst($4, -1);
+ 					$$ = (Node *)n;
+ 				}
+ 			| SPLIT PARTITION qualified_name AT VALUES '(' ListPartitionList ')' INTO qualified_name AND qualified_name
+ 				{
+ 					AlterTableCmd *n = makeNode(AlterTableCmd);
+ 					SplitPartitionStmt *s = makeNode(SplitPartitionStmt);
+ 					s->partNames = lappend(s->partNames, $3);
+ 					s->partNames = lappend(s->partNames, $10);
+ 					s->partNames = lappend(s->partNames, $12);
+ 					s->splitValues = $7;
+ 					n->subtype = AT_SplitPartition;
+ 					n->def = (Node *)s;
+ 					$$ = (Node *)n;
+ 				}
+ 			| MERGE PARTITIONS qualified_name AND qualified_name INTO qualified_name
+ 				{
+ 					AlterTableCmd *n = makeNode(AlterTableCmd);
+ 					MergePartitionStmt *s = makeNode(MergePartitionStmt);
+ 					s->partNames = lappend(s->partNames, $3);
+ 					s->partNames = lappend(s->partNames, $5);
+ 					s->partNames = lappend(s->partNames, $7);
+ 					n->subtype = AT_MergePartition; 
+ 					n->def = (Node *)s;
+ 					$$ = (Node *)n;
+ 				}
+ 
  			/* ALTER TABLE <name> DROP [COLUMN] <colname> [RESTRICT|CASCADE] */
  			| DROP opt_column ColId opt_drop_behavior
  				{
***************
*** 2035,2042 ****
   *
   *****************************************************************************/
  
! CreateStmt:	CREATE OptTemp TABLE qualified_name '(' OptTableElementList ')'
! 			OptInherit OptWith OnCommitOption OptTableSpace
  				{
  					CreateStmt *n = makeNode(CreateStmt);
  					$4->istemp = $2;
--- 2128,2135 ----
   *
   *****************************************************************************/
  
! CreateStmt: CREATE OptTemp TABLE qualified_name '(' OptTableElementList ')'
! 			   OptInherit OptWith OnCommitOption OptTableSpace OptPartition 
  				{
  					CreateStmt *n = makeNode(CreateStmt);
  					$4->istemp = $2;
***************
*** 2047,2056 ****
  					n->options = $9;
  					n->oncommit = $10;
  					n->tablespacename = $11;
  					$$ = (Node *)n;
  				}
  		| CREATE OptTemp TABLE qualified_name OF qualified_name
! 			'(' OptTableElementList ')' OptWith OnCommitOption OptTableSpace
  				{
  					/* SQL99 CREATE TABLE OF <UDT> (cols) seems to be satisfied
  					 * by our inheritance capabilities. Let's try it...
--- 2140,2150 ----
  					n->options = $9;
  					n->oncommit = $10;
  					n->tablespacename = $11;
+                     n->partAttr = $12;
  					$$ = (Node *)n;
  				}
  		| CREATE OptTemp TABLE qualified_name OF qualified_name
! 			'(' OptTableElementList ')' OptWith OnCommitOption OptTableSpace OptPartition
  				{
  					/* SQL99 CREATE TABLE OF <UDT> (cols) seems to be satisfied
  					 * by our inheritance capabilities. Let's try it...
***************
*** 2064,2073 ****
--- 2158,2304 ----
  					n->options = $10;
  					n->oncommit = $11;
  					n->tablespacename = $12;
+                     n->partAttr =  $13;
  					$$ = (Node *)n;
  				}
  		;
  
+ OptPartition: PARTITION BY PartitioningData { $$ = $3; }  
+ 		| {$$ = NULL;}
+     	;
+ 
+ PartitionColumns: ColId 				{$$ = list_make1(makeString($1));}
+ 		| PartitionColumns ',' ColId 	{$$ = lappend($1, makeString($3));}
+ 		;
+ 
+ PartitioningData: LIST1  '(' PartitionColumns ')'  '(' ListPartitions  ')'
+ 				{
+ 					PartitionAttrs *partData = makeNode(PartitionAttrs);
+ 					partData->partFunc = PART_LIST;
+ 					partData->numberOfPartitions = 0;
+ 					partData->colName = $3;
+ 					partData->partitions = $6;
+ 					$$ = (Node *)partData;
+ 				}
+ 			
+ 		| RANGE '(' PartitionColumns ')' '(' RangePartitions ')'
+ 				{
+ 					ListCell	*partition;
+ 					bool		isOverflow = false;
+                     PartitionAttrs *partData = makeNode(PartitionAttrs);
+ 					List	*partitions = NULL;
+ 
+ 					foreach(partition, $6)
+ 					{
+ 				        if(IsA(lfirst(partition), Alias))
+ 				        {
+ 				            if(strcmp(((Alias *)lfirst(partition))->aliasname, "default") == 0)
+ 				            {
+ 								if(isOverflow == false)
+ 								{
+ 									isOverflow = true;
+ 									partData->hasOverflowPartition = true;
+ 								}
+ 								else
+ 									elog(ERROR, "There can not be more than one default partitions.");
+ 				            }
+ 				        }
+ 						else if(IsA(lfirst(partition), Partition))
+ 						{
+ 							partitions = lappend(partitions, lfirst(partition));
+ 						}
+ 					}
+ 
+                     partData->partFunc = PART_RANGE;
+                     partData->numberOfPartitions = list_length(partitions);
+                     partData->colName = $3;
+                     partData->partitions = partitions;
+                     $$ = (Node *)partData;					
+ 				}	
+ 
+ 
+ 		| ColId '(' PartitionColumns ')'  PARTITIONS ICONST 
+ 				{
+ 					PartitionAttrs *partData = makeNode(PartitionAttrs);
+ 					if(strcasecmp($1, "hash") != 0)
+ 						elog(ERROR, "Not a valid partition type.");
+ 					partData->partFunc = PART_HASH;
+ 					partData->numberOfPartitions = $6;
+ 					partData->colName = $3;
+ 					partData->partitions =  NULL;
+ 					$$ = (Node *)partData;
+ 				}
+ 		;
+ 
+ ListPartitions: ListPartition 			{ $$ = list_make1($1);}
+ 	| ListPartitions ',' ListPartition 	{ $$ = lappend($1, $3);}
+ 	;
+ 
+ RangePartitions :  RangePartition { $$ = list_make1($1); }
+         | RangePartitions ',' RangePartition { $$ = lappend($1, $3); }
+ 		| RangePartitions ',' DEFAULT	{$$ = lappend($1, makeAlias("default", NULL));}
+         ;
+ 
+ ListPartitionList: a_expr 			{ $$ = list_make1($1);}
+ 	| ListPartitionList ',' a_expr 	{ $$ = lappend($1, $3);}
+ 	;
+ 
+ 
+ OptPartitionName: /* Empty  */ {$$ = NULL;}		
+ 	| qualified_name
+ 	;
+ 
+ ListPartition :	OptPartitionName '(' ListPartitionList ')'   OptTableSpace
+ 				{
+ 
+ 					Partition *partition = makeNode(Partition);
+ 					Constraint *constraint = NULL;
+ 					
+ 					partition->partName = $1;
+ 
+ 					/* Make the constraint node */
+ 					constraint = makeNode(Constraint);
+ 	
+ 					constraint->contype = PART_LIST;
+ 					constraint->name = NULL;
+ 					constraint->raw_expr = (Node *)$3; 
+ 					constraint->cooked_expr = NULL;
+ 					constraint->keys = NULL;
+ 					constraint->indexspace = NULL;
+ 					constraint->partition_list_values = $3;
+ 
+ 					partition->partitionCheck = constraint;
+ 					partition->tablespacename = $5;
+ 					$$ = (Node *)partition;
+ 				}
+     	;
+ 
+ RangePartition : OptPartitionName '(' START ListPartitionList END_P ListPartitionList ')' OptTableSpace
+ 				{
+ 
+ 						Partition *partition = makeNode(Partition);
+ 						Constraint *constraint = NULL;
+ 
+ 						partition->partName = $1;
+ 
+ 						/* Make the constraint node */
+ 						constraint = makeNode(Constraint);
+ 						constraint->contype = PART_RANGE;
+ 						constraint->min_value = $4;
+ 						constraint->max_value = $6;
+ 						constraint->name = NULL;
+ 			
+ 						/* constraint->raw_expr = $3; */
+ 
+ 						constraint->cooked_expr = NULL;
+ 						constraint->keys = NULL;
+ 						constraint->indexspace = NULL;
+ 
+ 						partition->partitionCheck = constraint;
+ 						partition->tablespacename = $8;
+ 						$$ = (Node *)partition;
+ 				}
+         ;
  /*
   * Redundancy here is needed to avoid shift/reduce conflicts,
   * since TEMP is not a reserved word.  See also OptTempTableName.
***************
*** 10276,10282 ****
  			| OWNER
  			| PARSER
  			| PARTIAL
- 			| PARTITION
  			| PASSWORD
  			| PLANS
  			| PRECEDING
--- 10507,10512 ----
***************
*** 10288,10294 ****
  			| PROCEDURAL
  			| PROCEDURE
  			| QUOTE
- 			| RANGE
  			| READ
  			| REASSIGN
  			| RECHECK
--- 10518,10523 ----
***************
*** 10323,10328 ****
--- 10552,10558 ----
  			| SHARE
  			| SHOW
  			| SIMPLE
+ 			| SPLIT
  			| STABLE
  			| STANDALONE_P
  			| START
***************
*** 10579,10585 ****
  
  %%
  
! static Node *
  makeColumnRef(char *colname, List *indirection, int location)
  {
  	/*
--- 10809,10815 ----
  
  %%
  
! Node *
  makeColumnRef(char *colname, List *indirection, int location)
  {
  	/*
Index: src/backend/parser/parse_utilcmd.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/parser/parse_utilcmd.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.2.1
diff -c -r1.1.1.2 -r1.1.1.2.2.1
*** src/backend/parser/parse_utilcmd.c	19 May 2009 06:59:32 -0000	1.1.1.2
--- src/backend/parser/parse_utilcmd.c	26 May 2009 08:04:45 -0000	1.1.1.2.2.1
***************
*** 75,80 ****
--- 75,81 ----
  	List	   *alist;			/* "after list" of things to do after creating
  								 * the table */
  	IndexStmt  *pkey;			/* PRIMARY KEY index, if any */
+ 	PartitionAttrs *partAttr; 	/* partitioning related info */
  } CreateStmtContext;
  
  /* State shared by transformCreateSchemaStmt and its subroutines */
***************
*** 114,119 ****
--- 115,121 ----
  static void transformConstraintAttrs(List *constraintList);
  static void transformColumnType(ParseState *pstate, ColumnDef *column);
  static void setSchemaName(char *context_schema, char **stmt_schema_name);
+ static void transformPartitionData(ParseState *pstate, CreateStmtContext *cxt);
  
  
  /*
***************
*** 177,182 ****
--- 179,185 ----
  	cxt.alist = NIL;
  	cxt.pkey = NULL;
  	cxt.hasoids = interpretOidsOption(stmt->options);
+ 	cxt.partAttr = (PartitionAttrs *)stmt->partAttr;
  
  	/*
  	 * Run through each primary element in the table creation clause. Separate
***************
*** 235,240 ****
--- 238,248 ----
  	transformFKConstraints(pstate, &cxt, true, false);
  
  	/*
+ 	 * Postprocess partition related information
+ 	 */
+ 	transformPartitionData(pstate, &cxt);
+ 
+ 	/*
  	 * Output results.
  	 */
  	stmt->tableElts = cxt.columns;
***************
*** 954,959 ****
--- 962,1062 ----
  
  	ReleaseSysCache(ht_opc);
  	return result;
+ }
+ 
+ /*
+  * transformPartitionData:
+  * If partitioning is specified, carry out checks on the supplied create stmt
+  */
+ static void
+ transformPartitionData(ParseState *pstate, CreateStmtContext *cxt)
+ {
+ 	PartitionAttrs 	*partAttr = (PartitionAttrs *)cxt->partAttr;
+ 	ListCell 		*lc, *temp_part; 
+ 	List *partitionList, *partindexlist = NIL;
+ 
+ 	if (partAttr == NULL)
+ 		return;
+ 
+ 	partitionList = partAttr->partitions;
+ 	/* Foreign key constraints not supported with partitioning */
+ 	if(cxt->fkconstraints)
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
+ 				 errmsg("FOREIGN KEY constraints not supported with partitioning")));
+ 
+ 	/*
+ 	 * Check if the primary key column is the one on which partitioning
+ 	 * is being done
+ 	 */
+ 
+ 	foreach(lc, cxt->ixconstraints)
+ 	{
+ 		Constraint  *constraint = lfirst(lc);
+ 		ListCell *partCol;
+ 		bool 	flag;
+ 
+ 		Assert(IsA(constraint, Constraint));
+ 
+ 		if(constraint->contype == CONSTR_PRIMARY ||
+ 		   constraint->contype == CONSTR_UNIQUE) 
+ 		{
+ /*
+ 			if (constraint->keys->length > 1) 
+ 			{
+ 				ereport(ERROR,
+ 						(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
+ 						 errmsg("PRIMARY/UNIQUE KEY with partitioning can specify"
+ 								" single attribute only")));
+ 			}
+ */
+ 			flag = false;
+ 
+ 			foreach(partCol, partAttr->colName)
+ 			{
+ 				Alias *partColName = lfirst(partCol);
+ 
+ 				if(strcmp(partColName->aliasname, strVal(lfirst(list_head(constraint->keys)))) == 0)
+ 					flag = true;
+ 			}
+ 
+ 			if(flag == false)			
+ 			{
+ 				ereport(ERROR,
+ 						(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
+ 						 errmsg("PRIMARY/UNIQUE KEY (%s) not the same as"
+ 								" the partitioning keys", strVal(lfirst(list_head(constraint->keys))))));
+ 			}
+ 		}
+ 	}
+ 
+ 	/*
+ 	 * cxt.alist contains index related entries, if so, we need to add entries
+ 	 * for the children tables too
+ 	 */
+ 	foreach(temp_part, partitionList)
+ 	{
+ 		Partition *temp_partition = lfirst(temp_part);
+ 
+ 		foreach(lc, cxt->alist)
+ 		{
+ 			IndexStmt  *index, *copyindex;
+ 
+ 			index = lfirst(lc);
+ 			Assert(IsA(index, IndexStmt));
+ 
+ 			copyindex = copyObject(index);
+ 			*(copyindex->relation) = *(temp_partition->partName);
+ 
+ 			partindexlist = lappend(partindexlist, copyindex);
+ 		}
+ 	}
+ 
+ 	/*
+ 	 * Append partindexlist to alist now, so that the indexes get created for
+ 	 * the children tables too
+ 	 */
+ 	cxt->alist = list_concat(cxt->alist, partindexlist);
  }
  
  
Index: src/backend/tcop/pquery.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/tcop/pquery.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.1
diff -c -r1.1.1.3 -r1.1.1.3.2.1
*** src/backend/tcop/pquery.c	19 May 2009 06:59:32 -0000	1.1.1.3
--- src/backend/tcop/pquery.c	26 May 2009 08:04:45 -0000	1.1.1.3.2.1
***************
*** 212,223 ****
  					lastOid = queryDesc->estate->es_lastoid;
  				else
  					lastOid = InvalidOid;
! 				snprintf(completionTag, COMPLETION_TAG_BUFSIZE,
! 				   "INSERT %u %u", lastOid, queryDesc->estate->es_processed);
  				break;
  			case CMD_UPDATE:
! 				snprintf(completionTag, COMPLETION_TAG_BUFSIZE,
! 						 "UPDATE %u", queryDesc->estate->es_processed);
  				break;
  			case CMD_DELETE:
  				snprintf(completionTag, COMPLETION_TAG_BUFSIZE,
--- 212,244 ----
  					lastOid = queryDesc->estate->es_lastoid;
  				else
  					lastOid = InvalidOid;
! 				
! 				/* If there are any overflow partition tuple then display message to user.*/
! 				if(queryDesc->estate->es_partition_overflow_tuples > 0)
! 				{
! 					snprintf(completionTag, COMPLETION_TAG_BUFSIZE,
! 				   	"INSERT %u %u \nNOTICE : Inserted partition key does not map to any partition. %u row(s) moved to overflow partition.", 
! 					lastOid, queryDesc->estate->es_processed, queryDesc->estate->es_partition_overflow_tuples);
! 				}
! 				else
! 				{
! 					snprintf(completionTag, COMPLETION_TAG_BUFSIZE,
! 				   	"INSERT %u %u", lastOid, queryDesc->estate->es_processed);
! 				}
  				break;
  			case CMD_UPDATE:
! 				/* If there are any overflow partition tuple then display message to user.*/
! 				if(queryDesc->estate->es_partition_overflow_tuples > 0)
! 				{
! 					snprintf(completionTag, COMPLETION_TAG_BUFSIZE,
! 						"UPDATE %u \nNOTICE : Latest partition key does not map to any partition. %u row(s) moved to overflow partition.", 
! 						queryDesc->estate->es_processed, queryDesc->estate->es_partition_overflow_tuples);
! 				}
! 				else
! 				{
! 					snprintf(completionTag, COMPLETION_TAG_BUFSIZE,
! 							 "UPDATE %u", queryDesc->estate->es_processed);
! 				}
  				break;
  			case CMD_DELETE:
  				snprintf(completionTag, COMPLETION_TAG_BUFSIZE,
Index: src/backend/tcop/utility.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/tcop/utility.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.2.1
diff -c -r1.1.1.2 -r1.1.1.2.2.1
*** src/backend/tcop/utility.c	19 May 2009 06:59:32 -0000	1.1.1.2
--- src/backend/tcop/utility.c	26 May 2009 08:04:45 -0000	1.1.1.2.2.1
***************
*** 57,62 ****
--- 57,63 ----
  #include "utils/guc.h"
  #include "utils/syscache.h"
  
+ extern bool IsPartition(Oid);
  
  /*
   * Verify user has ownership of specified relation, else ereport.
***************
*** 430,440 ****
  						relOid = DefineRelation((CreateStmt *) stmt,
  												RELKIND_RELATION);
  
  						/*
  						 * Let AlterTableCreateToastTable decide if this one
  						 * needs a secondary relation too.
  						 */
- 						CommandCounterIncrement();
  
  						/* parse and validate reloptions for the toast table */
  						toast_options = transformRelOptions((Datum) 0,
--- 431,446 ----
  						relOid = DefineRelation((CreateStmt *) stmt,
  												RELKIND_RELATION);
  
+ 						CommandCounterIncrement();
+ 						/*
+ 						 * Let DefinePartitions decide if partitions need to be created
+ 						 * for this table
+ 						 */
+ 						DefinePartitions((CreateStmt *)parsetree, relOid);
  						/*
  						 * Let AlterTableCreateToastTable decide if this one
  						 * needs a secondary relation too.
  						 */
  
  						/* parse and validate reloptions for the toast table */
  						toast_options = transformRelOptions((Datum) 0,
***************
*** 452,464 ****
  					}
  					else
  					{
! 						/* Recurse for anything else */
! 						ProcessUtility(stmt,
! 									   queryString,
! 									   params,
! 									   false,
! 									   None_Receiver,
! 									   NULL);
  					}
  
  					/* Need CCI between commands */
--- 458,478 ----
  					}
  					else
  					{
! 						/* Don't propagate primary/unique index over partitions.*/
! 						if( IsA(stmt, IndexStmt) && (true == IsPartition(RangeVarGetRelid(((IndexStmt *)stmt)->relation, false))))
! 						{
! 							continue;
! 						}
! 						else
! 						{
! 							/* Recurse for anything else */
! 							ProcessUtility(stmt,
! 										   queryString,
! 										   params,
! 										   false,
! 										   None_Receiver,
! 										   NULL);
! 						}
  					}
  
  					/* Need CCI between commands */
Index: src/backend/utils/adt/numeric.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/utils/adt/numeric.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.2.1
diff -c -r1.1.1.2 -r1.1.1.2.2.1
*** src/backend/utils/adt/numeric.c	19 May 2009 06:59:33 -0000	1.1.1.2
--- src/backend/utils/adt/numeric.c	26 May 2009 08:04:45 -0000	1.1.1.2.2.1
***************
*** 3633,3639 ****
  	char	   *endptr;
  
  	tmp = DatumGetCString(DirectFunctionCall1(numeric_out,
! 											  NumericGetDatum(num)));
  
  	/* unlike float8in, we ignore ERANGE from strtod */
  	val = strtod(tmp, &endptr);
--- 3633,3639 ----
  	char	   *endptr;
  
  	tmp = DatumGetCString(DirectFunctionCall1(numeric_out,
! 		 NumericGetDatum(num)));
  
  	/* unlike float8in, we ignore ERANGE from strtod */
  	val = strtod(tmp, &endptr);
Index: src/backend/utils/adt/ruleutils.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/utils/adt/ruleutils.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.2.1
diff -c -r1.1.1.2 -r1.1.1.2.2.1
*** src/backend/utils/adt/ruleutils.c	19 May 2009 06:59:33 -0000	1.1.1.2
--- src/backend/utils/adt/ruleutils.c	26 May 2009 08:04:45 -0000	1.1.1.2.2.1
***************
*** 44,49 ****
--- 44,51 ----
  #include "parser/parse_func.h"
  #include "parser/parse_oper.h"
  #include "parser/parsetree.h"
+ #include "parser/parse_clause.h"
+ #include "parser/parse_expr.h"
  #include "rewrite/rewriteHandler.h"
  #include "rewrite/rewriteManip.h"
  #include "rewrite/rewriteSupport.h"
***************
*** 6503,6506 ****
--- 6505,6546 ----
  	ReleaseSysCache(tuple);
  
  	return result;
+ }
+ 
+ /*
+  * get the text corresponding to a raw expr 
+  */
+ char *
+ pg_get_expr_text(RangeVar *relation, Node *raw_expr, StringInfo buf)
+ {
+ 	deparse_context context;
+ 	Node *opex;
+ 	Node *temp;
+ 	deparse_namespace dpns;
+ 	RangeVar *old;
+ 	RangeVar *new;
+ 	ParseState *pstate = make_parsestate(NULL);
+ 
+ 	old = makeNode(RangeVar);
+ 	old->relname = relation->relname;
+ 	old->alias = makeAlias("*OLD*", NIL);
+ 
+ 	new = makeNode(RangeVar);
+ 	new->relname = relation->relname;
+ 	new->alias = makeAlias("*NEW*", NIL);
+ 
+ 	transformFromClause(pstate, list_make3(relation, old, new));
+ 	temp = transformExpr(pstate, raw_expr);
+ 
+ 	opex = (Node *)temp;
+ 	context.buf = buf;
+ 	context.namespaces = list_make1(&dpns);
+ 	context.varprefix = true;
+ 	context.prettyFlags = PRETTYFLAG_PAREN | PRETTYFLAG_INDENT ;
+ 	context.indentLevel = PRETTYINDENT_STD;
+ 	dpns.rtable = pstate->p_rtable;
+ 	dpns.outer_plan = dpns.inner_plan = NULL;
+ 
+ 	get_rule_expr(opex, &context, false);
+ 	return (context.buf)->data;
  }
